#ifndef _KLP_2018_12207_H_
#define _KLP_2018_12207_H_

#ifndef CONFIG_X86_64
/* CVE-2018-11207 is x86-64 specific */
#else

#define KPATCH_CVE_2018_11207

#include <linux/livepatch.h>

/* vmlinux :: cpu/bugs.c patch hook refcounter */
#define KLP_SHADOW_CPU_BUGS_COUNT	0x2018122070000000

/* kvm :: arch/x86/kvm/mmu.c patch hook refcounter */
#define KLP_SHADOW_KVM_COUNT		0x2018122070000001

/* kpatch_itlb_multihit_kvm_mitigation */
#define KLP_SHADOW_KVM_MITIGATION	0x2018122070000010

/* kpatch_kvm_mutex */
#define KLP_SHADOW_KVM_MUTEX		0x2018122070000011

/*
 * Avoid modifying arch/x86/include/asm/msr-index.h and rebuilding all
 * includers.
 */
#define ARCH_CAP_PSCHANGE_MC_NO		BIT(6)	 /*
						  * The processor is not susceptible to a
						  * machine check error due to modifying the
						  * code page size along with either the
						  * physical address or cache type
						  * without TLB invalidation.
						  */

#define X86_BUG_ITLB_MULTIHIT		X86_BUG(23) /* CPU may incur MCE during certain page attribute changes */

bool kpatch_boot_cpu_has_itlb_multihit_bug(void);
bool kpatch_cpu_mitigations_off(void);

#endif /* CONFIG_X86_64 */
#endif /* _KLP_2018_12207_H_ */
